#include "LiquidCrystalProgmem.h"

/*  Copyright (c) 2020 Jaroslaw Weglinski based on LiquidCrystal Arduino library
    https://github.com/arduino-libraries/LiquidCrystal
    Changes licensed under GNU Lesser General Public License v.2.1 or any later version.*/

LiquidCrystalProgmem::LiquidCrystalProgmem(uint8_t rs,  uint8_t enable, uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3):
  LiquidCrystal {rs, enable, d0, d1, d2, d3} {
}

void LiquidCrystalProgmem::createCharProgMem(uint8_t location, const uint8_t charmap[]) {
  location &= 0x7; // we only have 8 locations 0-7
  command(LCD_SETCGRAMADDR | (location << 3));
  for (uint8_t i = 0; i < 8; i++) {
    write(pgm_read_byte_near(charmap + i));
  }
}

void LiquidCrystalProgmem::createChar(uint8_t location, const __FlashStringHelper *buf) {
  location &= 0x7; // we only have 8 locations 0-7
  command(LCD_SETCGRAMADDR | (location << 3));
  for (uint8_t i = 0; i < 8; i++) {
    write(pgm_read_byte_near((const uint8_t *)buf + i));
  }
}
